"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var fs_1 = __importDefault(require("fs"));
var path_1 = __importDefault(require("path"));
var template_1 = require("./template");
function generat_podcast_feed(podcastsConfig, locals) {
    var categories = locals.categories;
    if (podcastsConfig.path[podcastsConfig.path.length - 1] !== '/')
        podcastsConfig.path += '/';
    var podcast_category = categories.findOne({ name: podcastsConfig.name });
    var posts = podcast_category ? podcast_category.posts.sort('date', -1).data : [];
    var podcastItunesCategory = podcastsConfig.category.map(function (item) {
        var data = item.split(" - ");
        return {
            top: data[0],
            sub: data[1] ? data[1] : ''
        };
    });
    var FeedConfig = {
        title: podcastsConfig.title,
        subtitle: podcastsConfig.subtitle,
        feedUrl: hexo.config.url + "/" + podcastsConfig.path,
        homepage: hexo.config.url,
        description: podcastsConfig.description,
        logo: podcastsConfig.image,
        language: podcastsConfig.language,
        author: podcastsConfig.author,
        explicit: podcastsConfig.explicit,
        copyright: podcastsConfig.copyright,
        updatePeriod: "hourly",
        updateFrequency: 1,
        type: podcastsConfig.type,
        owner: podcastsConfig.owner,
        category: podcastItunesCategory,
        posts: posts
    };
    return {
        path: podcastsConfig.path,
        data: template_1.Template.generateFeed(FeedConfig)
    };
}
hexo.extend.generator.register('test', function (locals) {
    var podcastsConfig = hexo.config.podcasts;
    if (!podcastsConfig)
        return [];
    hexo.scaffold.get("episode").then(function (item) {
        if (!item) {
            var templateContent = fs_1.default.readFileSync(path_1.default.join(__dirname, "../template/episode.md"), "utf-8");
            hexo.scaffold.set("episode", templateContent);
        }
    });
    if (podcastsConfig instanceof Array) {
        var responseArray_1 = [];
        podcastsConfig.forEach(function (item) {
            responseArray_1.push(generat_podcast_feed(item, locals));
        });
        return responseArray_1;
    }
    if (podcastsConfig instanceof Object) {
        return generat_podcast_feed(podcastsConfig, locals);
    }
});
